"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = renderElement;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _warning = _interopRequireDefault(require("warning"));

function renderElement({
  /* eslint-disable react/prop-types */
  match,
  Component,
  isComponentResolved,
  hasComponent,
  querySubscription,
  resolving // Whether it's safe to throw a RedirectException or an HttpError.

  /* eslint-enable react/prop-types */

}) {
  const {
    route,
    router
  } = match;
  const {
    readyState,
    environment,
    variables
  } = querySubscription;
  const {
    error,
    props
  } = readyState;

  if (!route.render) {
    if (!isComponentResolved || !error && !props) {
      return undefined;
    }

    if (!props || !hasComponent) {
      process.env.NODE_ENV !== "production" ? (0, _warning.default)(hasComponent, 'Route with query `%s` has no render method or component.', querySubscription.getQueryName()) : void 0;
      return null;
    }

    return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
      match: match,
      router: router
    }, props));
  }

  return route.render(Object.assign({}, readyState, {
    match,
    Component: isComponentResolved ? Component : null,
    props: props && Object.assign({
      match,
      router
    }, props),
    environment,
    variables,
    resolving
  }));
}

module.exports = exports.default;